/**
 * Correção Prova Exame Final - C e C++ (disponibilizado em 09-10-2009)
 * Monitoria Técnicas de Programação 2023/1
 * Feito por: Daniel Augusto Pires de Castro
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct funcionario {
    char nome[20];
    float venda_nov;
    float venda_dez;
    float venda_jan;
} Funcionario;

/*
 * Questões 1.1 a 1.5 respectivamente 
*/
Funcionario* cadastrarFuncionarios(int n);
void imprimirPontuacaoCadaFuncionarioTresMeses(Funcionario funcionarios[], int n);
void imprimirPontuacaoGeralCadaMes(Funcionario funcionarios[], int n);
void imprimirMaiorPontuacao(Funcionario funcionarios[], int n);
float valorTotalVendidoFuncionarios(Funcionario funcionarios[], int n);

/*
 * Funções auxiliares para as questões
*/
Funcionario cadastrarFuncionario(char nome[20], float venda_nov, float venda_dez, float venda_jan);
void limpaBuffer();

int main (){

    Funcionario* funcionarios = NULL;
    
    printf("Pressione qualquer tecla para comecar.\n");

    do {
        limpaBuffer();
        

        // Questão 1.6
        printf("Escolha uma das opcoes entre 1 a 5.\n");
        printf("[1] Cadastrar funcionarios.\n");
        printf("[2] Mostrar pontuacao de cada funcionario nos tres meses.\n");
        printf("[3] Mostrar pontuacao de todos os funcionarios em cada mes.\n");
        printf("[4] Mostrar maior pontuacao atingida nos tres meses.\n");
        printf("[5] Mostrar valor total vendido de todos os funcionarios.\n");
        
        switch (getchar())
        {
        // Questão 1.1
        case '1':
            if (funcionarios == NULL){
                funcionarios = cadastrarFuncionarios(15);
                printf("Cadastro de funcionarios realizado com sucesso.\n");
            }
            else 
                printf("Os funcionarios ja estao cadastrados.\n");

            break;

        // Questão 1.2
        case '2':
            if (funcionarios != NULL)
                imprimirPontuacaoCadaFuncionarioTresMeses(funcionarios, 15);
            else 
                printf("Os funcionarios ainda nao foram cadastrados.\n");

            break;

        // Questão 1.3
        case '3':
            if (funcionarios != NULL)
                imprimirPontuacaoGeralCadaMes(funcionarios, 15);
            else 
                printf("Os funcionarios ainda nao foram cadastrados.\n");

            break;

        // Questão 1.4
        case '4':
            if (funcionarios != NULL)
                imprimirMaiorPontuacao(funcionarios, 15);
            else 
                printf("Os funcionarios ainda nao foram cadastrados.\n");

            break;

        // Questão 1.5
        case '5':
            if (funcionarios != NULL)
                // Questão 1.7
                printf("Valor total vendido pelos funcionarios: $ %.2f.\n", valorTotalVendidoFuncionarios(funcionarios, 15));
            else 
                printf("Os funcionarios ainda nao foram cadastrados.\n");

            break;
        default:
            printf("Comando invalido.\n");
            break;
        }
        limpaBuffer();

        printf("Continuar? S/N\n");

    } while(getchar() == 'S');

    return 0;
}

/*
 * Questão 1.1
 *
 * Há a possibilidade de cadastrar os dados do próprio usuário,
 * bastando usar a função scanf em um laço de 15 iterações pedindo
 * as quatro informações em cada.
 * 
 */
Funcionario* cadastrarFuncionarios(int n){
    if (n < 15)
        return NULL;

    Funcionario* funcionarios = (Funcionario*)malloc(n*sizeof(Funcionario));


    funcionarios[0] = cadastrarFuncionario("Alice", 1000, 1200, 1000);
    funcionarios[1] = cadastrarFuncionario("Pedro", 800, 700, 500);
    funcionarios[2] = cadastrarFuncionario("Ricardo", 1200, 1500, 1600);
    funcionarios[3] = cadastrarFuncionario("Jorge", 1100, 800, 1400);
    funcionarios[4] = cadastrarFuncionario("Tania", 1400, 1000, 700);
    funcionarios[5] = cadastrarFuncionario("Caio", 800, 1200, 900);
    funcionarios[6] = cadastrarFuncionario("Amanda", 1200, 1200, 900);
    funcionarios[7] = cadastrarFuncionario("Jane", 1600, 1200, 800);
    funcionarios[8] = cadastrarFuncionario("Olivia", 700, 1200, 800);
    funcionarios[9] = cadastrarFuncionario("Alfredo", 900, 700, 700);
    funcionarios[10] = cadastrarFuncionario("Gabriel", 1200, 1200, 1200);
    funcionarios[11] = cadastrarFuncionario("Carlos", 800, 800, 1600);
    funcionarios[12] = cadastrarFuncionario("Poliana", 1000, 700, 1600);
    funcionarios[13] = cadastrarFuncionario("Sandra", 700, 800, 900);
    funcionarios[14] = cadastrarFuncionario("Antonio", 1000, 2000, 200);

    return funcionarios;
}
/*
 * Auxiliar Questão 1.1
 */
Funcionario cadastrarFuncionario(char nome[20], float venda_nov, float venda_dez, float venda_jan){
    Funcionario funcionario;

    strcpy(funcionario.nome, nome);
    funcionario.venda_nov = venda_nov;
    funcionario.venda_dez = venda_dez;
    funcionario.venda_jan = venda_jan;

    return funcionario;
}

/*
 * Questão 1.2
 */
void imprimirPontuacaoCadaFuncionarioTresMeses(Funcionario funcionarios[], int n){
    int i = 0;
    float pontuacao = 0;

    for (i = 0; i < n; i++){
        pontuacao = (funcionarios[i].venda_nov + funcionarios[i].venda_dez + funcionarios[i].venda_jan)/100;
        printf("Pontuacao %s: %.2f.\n", funcionarios[i].nome, pontuacao);
    }
}

/*
 * Questão 1.3
 */
void imprimirPontuacaoGeralCadaMes(Funcionario funcionarios[], int n){
    int i = 0;
    float pontuacao_novembro = 0;
    float pontuacao_dezembro = 0;
    float pontuacao_janeiro = 0;

    for (i = 0; i < n; i++){
        pontuacao_novembro += funcionarios[i].venda_nov/100;
        pontuacao_dezembro += funcionarios[i].venda_dez/100;
        pontuacao_janeiro += funcionarios[i].venda_jan/100;
    }

    printf("Pontuacao Novembro: %.2f.\n", pontuacao_novembro);
    printf("Pontuacao Dezembro: %.2f.\n", pontuacao_dezembro);
    printf("Pontuacao Janeiro: %.2f.\n", pontuacao_janeiro);
}

/*
 * Questão 1.4
 */
void imprimirMaiorPontuacao(Funcionario funcionarios[], int n){
    int i = 0;
    float pontuacao = 0;
    float maior_pontuacao = 0;
    Funcionario melhor_funcionario = funcionarios[0];

    for (i = 0; i < n; i++){
        pontuacao = (funcionarios[i].venda_nov + funcionarios[i].venda_dez + funcionarios[i].venda_jan)/100;
        if (pontuacao > maior_pontuacao){
            melhor_funcionario = funcionarios[i];
            maior_pontuacao = pontuacao;
        }
    }
    printf("Maior pontuacao: %.2f, efetuada por: %s.\n", maior_pontuacao, melhor_funcionario.nome);
}

/*
 * Questão 1.5
 */
float valorTotalVendidoFuncionarios(Funcionario funcionarios[], int n){
    int i = 0;
    float valor = 0;

    for (i = 0; i < n; i++)
        valor += funcionarios[i].venda_nov + funcionarios[i].venda_dez + funcionarios[i].venda_jan;
    
    return valor;
}

/*
 * Função auxiliar para leitura do teclado com getchar() sem precisar armazenar valores
 */
void limpaBuffer(){
    while(getchar() != '\n');
}
