/**
 * Correção Prova Exame Final - C e C++ (disponibilizado em 09-10-2009)
 * Monitoria Técnicas de Programação 2023/1
 * Feito por: Daniel Augusto Pires de Castro
*/

#include <iostream>
#include <string>

using std::cout;
using std::endl;
using std::string;

/**
 * Questão 2.1
*/
class Funcionario {
    
    private:
        string nome;
        float venda_nov;
        float venda_dez;
        float venda_jan;

    public:
        Funcionario(string n = "", float vn = -1.0, float vd = -1.0, float vj = -1.0):
            nome(n), venda_nov(vn), venda_dez(vd), venda_jan(vj){
        }
        ~Funcionario(){
        }

        /**
         * 
         * Esses gets são necessários para replicar as questões anteriores. 
         * 
        */
        string getNome(){
            return nome;
        }
        float getVendaNov(){
            return venda_nov;
        }
        float getVendaDez(){
            return venda_dez;
        }
        float getVendaJan(){
            return venda_jan;
        }

        float calcularPontuacaoTresMeses(){
            return (venda_nov+venda_dez+venda_jan)/100;
        }
        void informarPontuacaoGeral(){
            cout << "Pontuacao " << nome << ": " << calcularPontuacaoTresMeses() << "." << endl;
        }
};

/**
 * Questão 2.2
*/
class Principal {
    
    private:

        /**
         * 
         * Caso houvesse mais objetos a serem instanciados,
         * seria mais conveniente fazer uma lista ou vetor
         * tal como na questão 1.
         * 
        */
        Funcionario alice;
        Funcionario pedro;
        Funcionario ricardo;
        Funcionario tania;

    public:
        Principal():
            alice(),
            pedro(),
            ricardo(),
            tania(){
        }
        ~Principal(){
        }

        /**
         * Como foram instanciados quatro objetos Funcionário na classe
         * Principal, eles apenas são preenchidos ao realizar o cadastro.
         * 
         * Assim como na questão 1, há a possibilidade de cadastrar os dados 
         * do próprio usuário, bastando usar o cin em um laço de 
         * 4 iterações pedindo as quatro informações em cada.
         * 
        */
        void cadastrarFuncionarios(){
            alice = Funcionario("Alice", 1300, 1200, 1000);
            pedro = Funcionario("Pedro", 800, 900, 1600);
            ricardo = Funcionario("Ricardo", 1600, 1600, 1000);
            tania = Funcionario("Tania", 800, 1200, 900);
        }

        /**
         * 
         * Como já existe uma função assim embutida na classe funcionário,
         * basta chamá-la para cada funcionário instanciado na principal. 
         * 
        */
        void imprimirPontuacaoCadaFuncionarioTresMeses(){
            alice.informarPontuacaoGeral();
            pedro.informarPontuacaoGeral();
            ricardo.informarPontuacaoGeral();
            tania.informarPontuacaoGeral();
        }

        /**
         * 
         * Os gets de cada mês são usados para serem armazenados em suas
         * respectivas variáveis.
         * Alternativamente, caso se tratasse de um vetor ou lista, seria
         * iterado cada objeto em um laço for para somar nas variáveis. 
         * 
        */
        void imprimirPontuacaoGeralCadaMes(){
            float pontuacao_novembro = (alice.getVendaNov() + pedro.getVendaNov() + ricardo.getVendaNov() + tania.getVendaNov())/100;
            float pontuacao_dezembro = (alice.getVendaDez() + pedro.getVendaDez() + ricardo.getVendaDez() + tania.getVendaDez())/100;
            float pontuacao_janeiro = (alice.getVendaJan() + pedro.getVendaJan() + ricardo.getVendaJan() + tania.getVendaJan())/100;

            cout << "Pontuacao Novembro: " << pontuacao_novembro << "." << endl;
            cout << "Pontuacao Dezembro: " << pontuacao_dezembro << "." << endl;
            cout << "Pontuacao Janeiro: " << pontuacao_janeiro << "." << endl;
        }

        /**
         * 
         * São calculadas as pontuacoes de um melhor funcionario escolhido 
         * arbitrariamente. A pontuacao dele é verificada com a do próximo
         * usuário.
         * Alternativamente, caso se tratasse de um vetor ou lista, seria
         * iterado cada objeto para fazer essa verificação em um laço for. 
         * 
        */
        void imprimirMaiorPontuacao(){
            Funcionario melhor_funcionario = alice;

            if (melhor_funcionario.calcularPontuacaoTresMeses() < pedro.calcularPontuacaoTresMeses())
                melhor_funcionario = pedro;
            if (melhor_funcionario.calcularPontuacaoTresMeses() < ricardo.calcularPontuacaoTresMeses())
                melhor_funcionario = ricardo;
            if (melhor_funcionario.calcularPontuacaoTresMeses() < tania.calcularPontuacaoTresMeses())
                melhor_funcionario = tania;
            
            cout << "Maior pontuacao: " << melhor_funcionario.calcularPontuacaoTresMeses() 
                 << " efetuada por: " << melhor_funcionario.getNome() << "." << endl;
        }

        /**
         * 
         * É usado o método já embutido na classe funcionário e o valor
         * é desconvertido da pontuação (bastando multiplicar por 100)
         * 
        */
        float valorTotalVendidoFuncionarios(){
            float valor = alice.calcularPontuacaoTresMeses()*100;
            valor += pedro.calcularPontuacaoTresMeses()*100;
            valor += ricardo.calcularPontuacaoTresMeses()*100;
            valor += tania.calcularPontuacaoTresMeses()*100;
                          
            return valor;
        }

        void executar(){
            bool ja_cadastrados = false;
            
            cout << "Pressione qualquer tecla para comecar." << endl;

            do {
                limpaBuffer();

                // Questão 1.6
                cout << "Escolha uma das opcoes entre 1 a 5." << endl;
                cout << "[1] Cadastrar funcionarios." << endl;
                cout << "[2] Mostrar pontuacao de cada funcionario nos tres meses." << endl;
                cout << "[3] Mostrar pontuacao de todos os funcionarios em cada mes." << endl;
                cout << "[4] Mostrar maior pontuacao atingida nos tres meses." << endl;
                cout << "[5] Mostrar valor total vendido de todos os funcionarios." << endl;

                switch (getchar())
                {
                // Questão 1.1
                case '1':
                    if (!ja_cadastrados){
                        cadastrarFuncionarios();
                        ja_cadastrados = true;
                        cout << "Cadastro de funcionarios realizado com sucesso." << endl;
                    }
                    else 
                        cout << "Os funcionarios ja estao cadastrados." << endl;

                    break;

                // Questão 1.2
                case '2':
                    if (ja_cadastrados)
                        imprimirPontuacaoCadaFuncionarioTresMeses();
                    else 
                        cout << "Os funcionarios ainda nao foram cadastrados." << endl;

                    break;

                // Questão 1.3
                case '3':
                    if (ja_cadastrados)
                        imprimirPontuacaoGeralCadaMes();
                    else 
                        cout << "Os funcionarios ainda nao foram cadastrados." << endl;

                    break;

                // Questão 1.4
                case '4':
                    if (ja_cadastrados)
                        imprimirMaiorPontuacao();
                    else 
                        cout << "Os funcionarios ainda nao foram cadastrados." << endl;

                    break;

                // Questão 1.5
                case '5':
                    if (ja_cadastrados)
                        // Questão 1.7
                        cout << "Valor total vendido pelos funcionarios: $" << valorTotalVendidoFuncionarios() << "." << endl;
                    else 
                        cout << "Os funcionarios ainda nao foram cadastrados." << endl;

                    break;
                default:
                    cout << "Comando invalido." << endl;
                    break;
                }
                limpaBuffer();

                cout << "Continuar? S/N" << endl;

            } while(getchar() == 'S');
        }

        /*
        * Método auxiliar para leitura do teclado com getchar() sem precisar armazenar valores
        */
        void limpaBuffer(){
            while(getchar() != '\n');
        }
};

/**
 * Questão 2.3
*/
int main () {
    Principal principal;

    principal.executar();

    return 0;
}